//
//  YHOtherInfoFillCell.swift
//  galaxy
//
//  Created by davidhuangA on 2024/2/18.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHOtherInfoFillCell: UITableViewCell {
    
    static let cellReuseIdentifier = "YHOtherInfoFillCell"
    
    
    typealias Block = () -> ()
    var block: Block?
    
    var dataModel: YHOtherInfoFillModel? {
        didSet {
            updateUI()
        }
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }
    
    override func layoutSubviews() {
        super.layoutSubviews()
        //        dotLineLayer.path = UIBezierPath(roundedRect: addBtn.bounds, cornerRadius: kCornerRadius6).cgPath
    }
    
    
    lazy var addBtn: UIButton = {
        let btn = UIButton()
        btn.setTitle("新增居住信息".local, for: .normal)
        btn.titleLabel?.font = UIFont.PFSC_M(ofSize: 14)
        btn.setTitleColor(UIColor.brandMainColor, for: .normal)
        btn.iconInLeft(spacing: 6)
        
        btn.setImage(UIImage(named: "form_add_info"), for: .normal)
        btn.addTarget(self, action: #selector(didClickAddBtn), for: .touchUpInside)
        return btn
    }()
    
    lazy var dotLineLayer:CAShapeLayer = {
        
        let borderLayer =  CAShapeLayer()
        borderLayer.position = CGPoint(x: addBtn.bounds.midX, y: addBtn.bounds.midY);
        borderLayer.path = UIBezierPath(roundedRect: borderLayer.bounds, cornerRadius: addBtn.layer.cornerRadius).cgPath
        borderLayer.lineWidth = 1
        //[数组第一个数字表示单个虚线长度，第二个数字表示间隔]
        borderLayer.lineDashPattern = [3,1]  as [NSNumber]?
        //前边是虚线的长度，后边是虚线之间空隙的长度
        borderLayer.lineDashPhase = 0.1
        //实线边框
        borderLayer.fillColor = UIColor.clear.cgColor
        borderLayer.strokeColor = UIColor.brandMainColor.cgColor
        return borderLayer
        
    }()
    
    
}

extension YHOtherInfoFillCell {
    @objc func didClickAddBtn() {
        printLog("点击了 添加按钮")
        
        var model = Residence()
        dataModel?.residences.append(model)
        self.block?()
    }
    
    func updateUI() {
        guard let dataModel = dataModel else { return}
        contentView.removeSubviews()
        contentView.backgroundColor = .clear
        
        //居住信息
        let holdView1 = UIView()
        holdView1.backgroundColor = .white
        holdView1.layer.cornerRadius = kCornerRadius6
        holdView1.clipsToBounds = true
        contentView.addSubview(holdView1)
        holdView1.snp.makeConstraints { make in
            make.edges.equalTo(0)
        }
        
        do {
            
            var lastTargetView : UIView!
            if dataModel.residences.count > 1 {
                
                for (index,item) in dataModel.residences.enumerated() {
                    if index == 0 {
                        let sessionView = YHOtherInfoSessionView(frame: .zero)
                        holdView1.addSubview(sessionView)
                        sessionView.snp.makeConstraints { make in
                            make.top.equalToSuperview()
                            make.left.equalToSuperview().offset(18)
                            make.right.equalToSuperview().offset(-18)
                            make.height.equalTo(YHOtherInfoSessionView.viewH)
                        }
                        
                        let residenceView = YHOtherResidenceFillView(frame: .zero)
                        holdView1.addSubview(residenceView)
                        
                        residenceView.snp.makeConstraints { make in
                            make.top.equalTo(sessionView.snp.bottom)
                            make.left.equalToSuperview().offset(18)
                            make.right.equalToSuperview().offset(-18)
                        }
                        
                        lastTargetView = residenceView
                    } else {
                        let sessionView = YHOtherInfoSessionView(frame: .zero)
                        sessionView.type = 1
                        sessionView.tag = index
                        sessionView.block = { tag in
                            if tag < dataModel.residences.count  {
                                dataModel.residences.remove(at: tag)
                                self.block?()
                            }
                        }
                        
                        holdView1.addSubview(sessionView)
                        sessionView.snp.makeConstraints { make in
                            make.top.equalTo(lastTargetView.snp.bottom).offset(kMargin)
                            make.left.equalToSuperview().offset(18)
                            make.right.equalToSuperview().offset(-18)
                            make.height.equalTo(YHOtherInfoSessionView.viewH)
                        }
                        
                        let residenceView = YHOtherResidenceFillView(frame: .zero)
                        holdView1.addSubview(residenceView)
                        residenceView.snp.makeConstraints { make in
                            make.top.equalTo(sessionView.snp.bottom)
                            make.left.equalToSuperview().offset(18)
                            make.right.equalToSuperview().offset(-18)
                        }
                        
                        lastTargetView = residenceView
                    }
                }
            } else {
                
                let sessionView = YHOtherInfoSessionView(frame: .zero)
                holdView1.addSubview(sessionView)
                sessionView.snp.makeConstraints { make in
                    make.top.equalToSuperview()
                    make.left.equalToSuperview().offset(18)
                    make.right.equalToSuperview().offset(-18)
                    make.height.equalTo(YHOtherInfoSessionView.viewH)
                }
                
                let residenceView = YHOtherResidenceFillView(frame: .zero)
                holdView1.addSubview(residenceView)
                residenceView.snp.makeConstraints { make in
                    make.top.equalTo(sessionView.snp.bottom)
                    make.left.equalToSuperview().offset(18)
                    make.right.equalToSuperview().offset(-18)
                }
                
                lastTargetView = residenceView
            }
            
            
            
            //添加按钮
            holdView1.addSubview(addBtn)
            addBtn.layer.addSublayer(dotLineLayer)
            
            
            addBtn.snp.makeConstraints { make in
                make.top.equalTo(lastTargetView.snp.bottom).offset(kMargin)
                make.left.equalToSuperview().offset(18)
                make.right.equalToSuperview().offset(-18)
                make.height.equalTo(44)
                
                make.bottom.equalToSuperview().offset(-18)
            }
            addBtn.layoutIfNeeded()
            dotLineLayer.path = UIBezierPath(roundedRect: CGRect(x: 0, y: 0, width: KScreenWidth - 18 * 2 - 16 * 2, height: 44), cornerRadius: kCornerRadius6).cgPath
        }
        
    }
}
